/*****************************************************************************

 JOCO's ZX spectrum emulator.
 keytab.h: aux. tables for keyboard mapping

 see the file read.me for details/legal

******************************************************************************/

   unsigned char Key_tab[83]={
/*
 99 - illegal key for Spectrum, ignore
 bit0..2: keyrow ZXKBD (0..7)
 bit3   : 0
 bit4   : 0
 bit5   : 0
 bit6   : must press/release the Symbol-Shift bit as well
 bit7   : must press/release the Caps-Shift bit as well
*/

    99,   // ESC                1 
   0x03,  // 1                  2 
   0x03,  // 2                  3 
   0x03,  // 3                  4 
   0x03,  // 4                  5 
   0x03,  // 5                  6 
   0x04,  // 6                  7 
   0x04,  // 7                  8 
   0x04,  // 8                  9 
   0x04,  // 9                 10 
   0x04,  // 0                 11 
    99,   // -                 12 
   0x46,  // =                 13 
   0x84,  // Backspace         14 
   0x87,  // TAB               15 
   0x02,  // q                 16 
   0x02,  // w                 17 
   0x02,  // e                 18 
   0x02,  // r                 19 
   0x02,  // t                 20 
   0x05,  // y                 21 
   0x05,  // u                 22 
   0x05,  // i                 23 
   0x05,  // o                 24 
   0x05,  // p                 25 
    99,   // [                 26 
    99,   // ]                 27 
   0x06,  // Enter             28 
    99,   // Ctrl              29 
   0x01,  // a                 30 
   0x01,  // s                 31 
   0x01,  // d                 32 
   0x01,  // f                 33 
   0x01,  // g                 34 
   0x06,  // h                 35 
   0x06,  // j                 36 
   0x06,  // k                 37 
   0x06,  // l                 38 
   0x45,  // ;                 39 
   0x45,  // '                 40 
   0x83,  // `                 41 
   0x00,  // Left-Shift        42 
    99,   // \                 43 
   0x00,  // z                 44 
   0x00,  // x                 45 
   0x00,  // c                 46 
   0x00,  // v                 47 
   0x07,  // b                 48 
   0x07,  // n                 49 
   0x07,  // m                 50 
   0x47,  // ,                 51 
   0x47,  // .                 52 
    99,   // /                 53 
   0x00,  // Right-Shift       54 
    99,   // Print Screen      55 
   0x07,  // Alt               56 
   0x07,  // SPACE             57 
   0x83,  // Caps Lock         58 
    99,   // f1                59 
    99,   // f2                60 
    99,   // f3                61 
    99,   // f4                62 
    99,   // f5                63 
    99,   // f6                64 
    99,   // f7                65 
    99,   // f8                66 
    99,   // f9                67 
    99,   // f10               68 
   0x84,  // Num Lock          69 
    99,   // Scroll Lock       70 
    99,   // 7 Numeric Keypad  71 
   0x04,  // 8                 72 
    99,   // 9                 73 
    99,   // -                 74 
   0x03,  // 4                 75 
    99,   // 5                 76 
   0x04,  // 6                 77 
    99,   // +                 78 
    99,   // 1                 79 
   0x04,  // 2                 80 
    99,   // 3                 81 
    99,   // 0                 82 
   0x47}; // .                 83 

  /* Bitnumbers for the keyboard table (in ZXKBD) */

   unsigned char Key_tab_bit[]={
     0,  // ESC                1 
     1,  // 1                  2 
     2,  // 2                  3 
     4,  // 3                  4 
     8,  // 4                  5 
    16,  // 5                  6 
    16,  // 6                  7 
     8,  // 7                  8 
     4,  // 8                  9 
     2,  // 9                 10 
     1,  // 0                 11 
     0,  // -                 12 
     2,  // =                 13 
     1,  // Backspace         14 
     2,  // TAB               15 
     1,  // q                 16 
     2,  // w                 17 
     4,  // e                 18 
     8,  // r                 19 
    16,  // t                 20 
    16,  // y                 21 
     8,  // u                 22 
     4,  // i                 23 
     2,  // o                 24 
     1,  // p                 25 
     0,  // [                 26 
     0,  // ]                 27 
     1,  // Enter             28 
     0,  // Ctrl              29 
     1,  // a                 30 
     2,  // s                 31 
     4,  // d                 32 
     8,  // f                 33 
    16,  // g                 34 
    16,  // h                 35 
     8,  // j                 36 
     4,  // k                 37 
     2,  // l                 38 
     2,  // ;                 39 
     1,  // '                 40 
     1,  // `                 41 
     1,  // Left-Shift        42 
     0,  // \                 43 
     2,  // z                 44 
     4,  // x                 45 
     8,  // c                 46 
    16,  // v                 47 
    16,  // b                 48 
     8,  // n                 49 
     4,  // m                 50 
     8,  // ,                 51 
     4,  // .                 52 
     0,  // /                 53 
     1,  // Right-Shift       54 
     0,  // Print Screen      55 
     2,  // Alt               56 
     1,  // SPACE             57 
     2,  // Caps Lock         58 
     0,  // f1                59 
     0,  // f2                60 
     0,  // f3                61 
     0,  // f4                62 
     0,  // f5                63 
     0,  // f6                64 
     0,  // f7                65 
     0,  // f8                66 
     0,  // f9                67 
     0,  // f10               68 
     2,  // Num Lock          69 
     0,  // Scroll Lock       70 
     8,  // 7 Numeric Keypad  71 
     8,  // 8                 72 
     2,  // 9                 73 
     0,  // -                 74 
    16,  // 4                 75 
    16,  // 5                 76 
     4,  // 6                 77 
     0,  // +                 78 
     1,  // 1                 79 
    16,  // 2                 80 
     4,  // 3                 81 
     1,  // 0                 82 
     4}; // .                 83 

    unsigned char ZXKBD[8]={
    255,  //  v  c  x  z  caps  
    255,  //  g  f  d  s  a     
    255,  //  t  r  e  w  q     
    255,  //  5  4  3  2  1     
    255,  //  6  7  8  9  0     
    255,  //  y  u  i  o  p     
    255,  //  h  j  k  l  enter 
    255}; //  b  n  m sym space 

