/*****************************************************************************

 JOCO's ZX spectrum emulator.
 z80cpu.h: header file for the variables/functions implemented in the
           z80main.o file (which is written in assembly language)

 see the file read.me for details/legal

******************************************************************************/

#ifndef _Z80CPU_HEADER
#define _Z80CPU_HEADER

#ifndef _JOCOTYPES
#define _JOCOTYPES
/* my basic types... why C does not know them by default??? */
typedef unsigned char 		byte;
typedef unsigned short		word;
typedef unsigned int		dword;
#endif

byte *Z80mem;		/* pointer for spectrum main mem 		*/
byte *Z80memSpec;	/* pointer for spectrum mem spec. array 	*/
void SpecWriteByte();	/* write a special byte	(screen/attr)		*/
void SpecWriteWord();	/* write a special word (screen/attr)		*/
void ByteIn();		/* in */
void ByteOut();		/* out */
void ExtSub();		/* external function */

extern void Z80Reset();	/* CPU reset */
extern void ExecOne();	/* Execute one Z80 instruction */

/* Z80 Registers and hardware flags */			
extern dword Z_BC,Z_DE,Z_HL,Z_AF,Z_BC2,Z_DE2,Z_HL2,Z_AF2,Z_IX,Z_IY;
extern dword Z_SP,Z_PC,Z_ICtr;
extern byte  Z_IFF1,Z_IFF2,Z_IMOD,HWFlag,Z_I,Z_R,Z_IM2V;

#endif